#include <iostream>
#include <random>
#include <chrono>

void generate(short min_char_count, short max_char_count, short min_num_count, short max_num_count, int count, std::string seed)
{
	std::mt19937 engine;

	if(seed != "")
	{
		std::seed_seq seq(seed.begin(),seed.end());
		engine.seed(seq);
	}
	else
	{
		engine.seed(std::chrono::system_clock::now().time_since_epoch().count());
	}

	std::uniform_int_distribution<short> char_count_distribution(min_char_count, max_char_count);
	std::uniform_int_distribution<char> char_distribution('a', 'z');
	std::uniform_int_distribution<char> num_distribution(0, 9);
	std::uniform_int_distribution<short> num_count_distribution(min_num_count, max_num_count);

	for(int j = 0; j < count; ++j)
	{
		short char_count = char_count_distribution(engine);
		short num_count = num_count_distribution(engine);

		char_count -= num_count;
	
		for(short i = 0; i < char_count; ++i)
		{
			std::cout << char_distribution(engine);
		}

		for(short i = 0; i < num_count; ++i)
		{
			char c = num_distribution(engine) + 0x30; // convert to ascii
			std::cout << c;
		}

		std::cout << std::endl;
	}
}
